#ifndef loop

#if 0
/* this had to be disabled because of the new 1999 C standard ... */
#ifdef DOS
/* simple version that works in most cases incl. GCC <= 2.3.3 */
#define loop(_I,_From,_To) for (_I=_From;_I<_To;_I++)
#else
/* this obfuscation is required by GCC newer than 2.3.3
   otherwise statements like `loop (i,0,=6)' do not work */
#define _CAT4LOOP(_A,_OP,_B) _A##_OP##_B
#define loop(_I,_From,_To) for (_I=_From;_CAT4LOOP(_I,<,_To);_I++)
#endif
#endif

/* C-style loop (last not included) */
#define loop(_I,_From,_To) for (_I=_From;_I<_To;_I++)

/* Pascal etc. style loop (last included) */
#define loopto(_I,_From,_To) for (_I=_From;_I<=_To;_I++)

/* loop over linked list.  Example:
   struct mylist_s {
     struct mylist_s *next; // next item; NULL terminates the list
     char text[8]; } 
   *head,*l;
   looplist (l,head) printf("%s\n",l->text);
*/
#define looplist(_X,_Y) for (_X=(_Y);_X;_X=_X->next)

#endif
